
precision lowp float;

// ---------------------------------------------------------------------

varying mediump vec2    v_iTexCoord;

uniform lowp sampler2D  u_image;

// ---------------------------------------------------------------------

vec3    luminance_lut( in vec3 color );

vec3    vibrance( in vec3 color );
vec3    white_balance_srgb( in vec3 color );
vec3    color_adjust( in vec3 color );

float   greyscale_blend( in vec3 color );
vec3    greyscale_tint( in float grey );
vec3    greyscale_adjust( in vec3 color );
float   greyscale_lum( in vec3 color );

float   alpha_adjust( in float alpha );

vec3    final_mix( in vec3 color, in vec3 grey, in float alpha );
vec3    ruby_mix(  in vec3 grey, in float alpha );

// ---------------------------------------------------------------------

void main()
{    
    lowp vec3 color      = texture2D( u_image, v_iTexCoord ).rgb;

    // luminance lut
    color           = luminance_lut( color );

    // greyscale blend
    lowp float grey = greyscale_blend( color );

    // color (vibrance + whitebalance) adjustment
    color           = color_adjust( color );
    
    gl_FragColor    = vec4( color, grey );
}
